// Custom component script
// Name of the component must match the name of written in XML attribute eg.
// <g id="someID" rexsvg:module="CustomComponent" >
//

REX.UI.SVG.CustomComponent = function(svgElem,args) {
    // Inherit from base component
    var that = new REX.UI.SVG.Component(svgElem,args);
    // Store options for simple usage
    var $o = that.options || {};
    
    // Root level element
    var element = that.element;
    
    // Find element by rexsvg:tag attribute
    // and convert it to the SVG.JS object
    // see http://svgjs.com/ for more info
    var rect = SVG.adopt(that.getChildByTag("rectangle"));   
    
    var text = SVG.adopt(that.getChildByTag("text"));
    
    
    // Check if connection string 'value' is marked as writable
    if (that.$c.value.type === 'R') {
        that.log.error('Connection String: ' + that.$c.value.cstring + '(' + that.$c.value.alias + ') is read-only');
        return that;
    }
    
    // If the value is changed within the REX system 
    // process the value and show it
    that.$c.value.on('change', function(itm) {        
        var val  = itm.getValue();
        that.log.info('Value changed to: '+val);
    });

    // Add event listener
    // see http://svgjs.com/events/
    rect.on('mousemouve',function(evt){
        var point = element.createSVGPoint(event.pageX,event.pageY);        
        var CTM = element.getScreenCTM();
        
        if (/Firefox[\/\s](\d+\.\d+)/.test(navigator.userAgent)) {
            point = point.matrixTransform(CTM.inverse());
            point.x -= (rect.getBBox().x);            
        } else {
            point = point.matrixTransform(CTM.inverse());
        }
        text.text('Point ['+point.x+','+point.y+']');
    });
    
    that.enable();    
    return that;
};
